"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Created by Administrator on 2016/7/26.
 */
var React = require("react");
var AttachTable = require("./AttachMgrTable");

var _require = require("yylib-ui"),
    YYClass = _require.YYClass,
    YYModal = _require.YYModal,
    YYButton = _require.YYButton,
    YYTree = _require.YYTree,
    YYTreeNode = _require.YYTreeNode,
    YYCol = _require.YYCol,
    YYRow = _require.YYRow;

var _require2 = require("lodash"),
    isFunction = _require2.isFunction;

var ADDR = require("../../BaseHost");
var AttachmentMgrModal = YYClass.create({
  getDefaultProps: function getDefaultProps() {
    return {
      serverUrl: ADDR,
      fileUrl: ADDR,
      value: null,
      fileTypes: "",
      showUploadBtn: true,
      showDelBtn: true,
      readOnly: false,
      beforeUpload: null,
      beforeDel: null,
      userId: "",
      userName: "",
      enableUser: true,
      deleteTip: "删除的附件不可恢复！确定要删除？"
    };
  },
  getInitialState: function getInitialState() {
    return {
      visible: false,
      sourceId: this.props.sourceId || null,
      billType: null,
      sourceType: this.props.sourceType ? this.props.sourceType : "102345678",
      loading: false,
      value: null,
      defaultKey: ""
    };
  },

  changeValue: function changeValue(value, fileLength) {
    if (!this.props.readOnly) {
      if (isFunction(this.props.onChange)) {
        this.props.onChange(value, fileLength);
      }
    }
  },
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    //解决sourceId发生变化的时候组件的返回值问题
    var lastSourceId = this.state.sourceId;
    if (!lastSourceId) {
      lastSourceId = "";
    }
    var sourceId = nextProps.sourceId;
    if (!sourceId) {
      sourceId = "";
    }
    this.setState({ sourceId: sourceId });
    if (sourceId != lastSourceId && lastSourceId !== "") {
      //如果sourceId变化，则组件的值为空
      this.changeValue(null);
    }
    if (nextProps.sourceType) {
      this.setState({ sourceType: nextProps.sourceType });
    }
  },
  componentWillMount: function componentWillMount() {
    var fileTypeMap = this.props.fileTypes;
    if (fileTypeMap) {
      var defaultKey = fileTypeMap[0].code;
      this.setState({
        defaultKey: defaultKey,
        fileTypes: fileTypeMap,
        sourceType: defaultKey
      });
    }
  },
  handleCancel: function handleCancel() {
    if (isFunction(this.props.onCancel)) {
      this.props.onCancel();
    }
  },
  onSelectNode: function onSelectNode(selectedKeys, info) {
    //console.log(selectedKeys,info);
    var key = selectedKeys[0];
    this.setState({ sourceType: key });
    if (isFunction(this.props.onSelect)) {
      this.props.onSelect(selectedKeys, info);
    }
  },
  render: function render() {
    var that = this;
    var nameMap = this.props.fileTypes;
    console.log(this.props.userId, this.props.userName, "---===");

    //是否定义文件分类
    var showTree = false;
    var tableWidth = 24;
    if (nameMap) {
      showTree = true;
      tableWidth = 19;
    }
    var defaultKey = this.state.defaultKey;
    var loop = function loop(data) {
      return data.map(function (item) {
        return React.createElement(YYTreeNode, { key: item.code, title: item.name });
      });
    };
    return React.createElement(
      YYModal,
      {
        ref: "modal",
        wrapClassName: "vertical-center-infomodal",
        visible: this.props.visible,
        title: "\u9644\u4EF6\u7BA1\u7406",
        width: "980",
        onCancel: this.handleCancel,
        footer: [React.createElement(
          YYButton,
          { key: "back", onClick: this.handleCancel },
          "\u5173\u95ED"
        )]
      },
      React.createElement(
        YYRow,
        { className: "batch-opt" },
        showTree ? React.createElement(
          YYCol,
          { span: "5" },
          React.createElement(
            YYTree,
            {
              defaultSelectedKeys: defaultKey,
              onSelect: this.onSelectNode
            },
            loop(nameMap)
          )
        ) : "",
        React.createElement(
          YYCol,
          { span: tableWidth },
          React.createElement(AttachTable, _extends({}, this.props, {
            serverUrl: this.props.serverUrl,
            fileUrl: this.props.fileUrl,
            readOnly: this.props.readOnly,
            modal: this,
            billType: this.props.billType,
            showUploadBtn: this.props.showUploadBtn,
            showDelBtn: this.props.showDelBtn,
            sourceId: this.state.sourceId,
            sourceType: this.state.sourceType,
            pageVisible: true,
            beforeUpload: this.props.beforeUpload,
            beforeDel: this.props.beforeDel,
            userId: this.props.userId,
            userName: this.props.userName,
            enableUser: this.props.enableUser,
            deleteTip: this.props.deleteTip,
            multiple: this.props.multiple
          }))
        )
      )
    );
  }
});
module.exports = AttachmentMgrModal;