'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Created by Administrator on 2016/5/11.
 * 上传附件组件
 */
var React = require('react');

var _require = require('yylib-ui'),
    YYClass = _require.YYClass,
    YYButton = _require.YYButton,
    YYDropdownButton = _require.YYDropdownButton,
    YYMenu = _require.YYMenu,
    YYMenuItem = _require.YYMenuItem,
    YYMessage = _require.YYMessage;

var ADDR = require('../BaseHost');
var ajax = require('yylib-utils/ajax');
var AuthToken = require("../../utils/AuthToken");
/**
 * 根据billtype单据类型获取该单据类型的
 * @type {string}
 */
var templateUrl = "/icop-print/print/getTptList";
//加载打印模板信息
function loadTplList(url, params, onSuccess, onError) {
    ajax.postJSON(url, params, function (data) {
        if (data && data.success) {
            if (onSuccess) {
                onSuccess(data.backData);
            }
        } else {
            if (onError) {
                onError("查询打印模板数据失败");
            }
        }
    }, function (error) {
        if (onError) {
            onError("请求打印模板的服务失败");
        }
    });
}

var PrintButton = YYClass.create({
    getDefaultProps: function getDefaultProps() {
        return {
            serverUrl: ADDR,
            templateUrl: templateUrl,
            billType: '',
            busiType: '',
            enableOrg: false,
            orgId: '',
            onClickMenu: null,
            title: '打印',
            disable: false,
            _type: 'YYPage',
            type: null, //按钮类型
            align: 'left', //按钮浮动方向，left-向左浮动、right-向右浮动
            ghost: false, //设置按钮为不填充形态
            btnCls: null, // 用于更改样式
            menuCls: null, // 用于更改样式
            menuItemCls: null, // 用于更改样式
            dropdownCls: null // 用于更改样式
        };
    },
    getInitialState: function getInitialState() {
        return { hashLoad: false, templateList: [] };
    },
    _loadList: function _loadList(billType, busiType, orgId) {
        //添加单据判断
        if (billType) {
            var url = this.props.serverUrl + this.props.templateUrl;
            var that = this;
            loadTplList(url, { billType: billType, busiType: busiType, orgId: orgId }, function (backData) {
                that.setState({ templateList: backData || [] });
            }, function (errMsg) {
                that.setState({ templateList: [] });
                YYMessage.error(errMsg);
            });
        }
    },
    componentDidMount: function componentDidMount() {
        if (this.state.hashLoad == false) {
            this.setState({ hashLoad: true });

            var billType = this.props.billType;
            var busiType = this.props.busiType;
            var orgId = this.props.orgId;
            if (this.props.enableOrg) {
                orgId = AuthToken.getOrgaId();
            }
            this._loadList(billType, busiType, orgId);
        }
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        var newBillType = nextProps.billType;
        var newEnableOrg = nextProps.enableOrg;
        var newOrgId = nextProps.orgId;
        var newBusiType = nextProps.busiType;
        if (newBillType == this.props.billType && newEnableOrg == this.props.enableOrg && newOrgId == this.props.orgId && newBusiType == this.props.busiType) {
            return;
        }
        if (newEnableOrg === true) {
            newOrgId = AuthToken.getOrgaId();
        }
        this._loadList(newBillType, newBusiType, newOrgId);
    },
    handleMenuClick: function handleMenuClick(e) {
        this.handleClick(e.key, e.item.props.boCode);
    },
    handleClick: function handleClick(templateCode, boCode) {
        var eventHandler = this.props.onClickMenu;
        if (eventHandler) {
            if (boCode) {
                window.sessionStorage.setItem('boCode', boCode);
            } else {
                window.sessionStorage.removeItem('boCode');
            }
            eventHandler(templateCode);
        }
    },

    getMenu: function getMenu(data) {
        var _this = this;
        return React.createElement(
            YYMenu,
            { className: this.props.menuCls, onClick: this.handleMenuClick },
            data.map(function (item, index) {
                var templateName = item.templateName;
                if (!templateName) {
                    templateName = "打印模板" + (index + 1);
                }
                return React.createElement(
                    YYMenuItem,
                    { className: _this.props.menuItemCls, key: item.templateCode, disabled: false, boCode: item.boCode },
                    templateName
                );
            })
        );
    },

    render: function render() {
        var title = this.props.title || '打印';
        var data = this.state.templateList || [];
        //console.log("data",data);
        var _props = this.props,
            dropdownCls = _props.dropdownCls,
            btnCls = _props.btnCls,
            className = _props.className,
            type = _props.type,
            ghost = _props.ghost,
            align = _props.align,
            style = _props.style;

        var defaultProps = { type: type, ghost: ghost };
        defaultProps.disabled = this.props.disabled;
        if (align === 'right') {
            defaultProps.style = style || {};
            defaultProps.style.float = 'right';
        }
        btnCls = (btnCls ? btnCls : '') + (className ? ' ' + className : '');
        dropdownCls = (dropdownCls ? dropdownCls : '') + (className ? ' ' + className : '');

        if (!data || data.length == 0) {
            return React.createElement(
                YYButton,
                _extends({}, defaultProps, { className: btnCls }),
                '\u65E0\u6253\u5370\u6A21\u677F'
            );
        } else if (data && data.length == 1) {
            var item = data[0];
            return React.createElement(
                YYButton,
                _extends({}, defaultProps, { onClick: this.handleClick.bind(this, item.templateCode, item.boCode), className: btnCls }),
                title
            );
        } else if (data && data.length > 0) {
            var menus = this.getMenu(data);
            return React.createElement(
                YYDropdownButton,
                _extends({ className: dropdownCls, overlay: menus }, defaultProps),
                title
            );
        }
    }
});

module.exports = PrintButton;