"use strict";

var React = require('react');
var ReactDOM = require('react-dom');
var Trigger = require('rc-trigger');
var YYMenu = require('../../menu/YYMenu');

var _require = require('./utils'),
    preventDefaultEvent = _require.preventDefaultEvent;

var BUILT_IN_PLACEMENTS = {
    bottomLeft: {
        points: ['tl', 'bl'],
        offset: [0, 4],
        overflow: {
            adjustX: 0,
            adjustY: 1
        }
    },
    topLeft: {
        points: ['bl', 'tl'],
        offset: [0, -4],
        overflow: {
            adjustX: 0,
            adjustY: 1
        }
    }
};

var TriggerMenu = React.createClass({
    displayName: 'TriggerMenu',


    getDefaultProps: function getDefaultProps() {
        return {
            prefixCls: 'ant-dropdown'
        };
    },

    componentDidUpdate: function componentDidUpdate() {
        var visible = this.props.visible;

        if (visible) {
            var dropdownDOMNode = this.refs.trigger.getPopupDomNode();
            if (dropdownDOMNode) {
                dropdownDOMNode.style['minWidth'] = ReactDOM.findDOMNode(this).offsetWidth + 'px';
            }
        }
    },


    //渲染菜单
    renderMenu: function renderMenu() {
        var _props = this.props,
            maxSize = _props.maxSize,
            options = _props.options,
            onMenuSelect = _props.onMenuSelect,
            prefixCls = _props.prefixCls;

        return React.createElement(
            YYMenu,
            {
                prefixCls: prefixCls + '-menu',
                onClick: onMenuSelect
            },
            options
        );
    },


    //弹出容器
    getDropdownElement: function getDropdownElement() {
        var _props2 = this.props,
            prefixCls = _props2.prefixCls,
            style = _props2.style;

        var renderMenu = this.renderMenu();
        return renderMenu ? React.createElement(
            'div',
            {
                className: 'yyui-autoselect-dropdown-popup',
                style: style,
                onMouseDown: preventDefaultEvent
            },
            renderMenu
        ) : null;
    },
    render: function render() {
        var _props3 = this.props,
            visible = _props3.visible,
            children = _props3.children;

        var popupElement = this.getDropdownElement();

        return React.createElement(
            Trigger,
            {
                showAction: ['click'],
                hideAction: ['blur'],
                ref: 'trigger',
                popupPlacement: 'bottomLeft',
                builtinPlacements: BUILT_IN_PLACEMENTS,
                popup: popupElement,
                popupVisible: visible
            },
            children
        );
    }
});

module.exports = TriggerMenu;