'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 重写Antd的Table组件相关实现 by dio
 */
var React = require('react');

var _require = require('antd'),
    Table = _require.Table,
    Spin = _require.Spin,
    Checkbox = _require.Checkbox;

var RcTable2 = require('./RcTable');
var classnames = require('classnames');
var _ = require('lodash');

function noop() {}

var AntdTable = function (_Table) {
    _inherits(AntdTable, _Table);

    function AntdTable(props) {
        _classCallCheck(this, AntdTable);

        var _this2 = _possibleConstructorReturn(this, (AntdTable.__proto__ || Object.getPrototypeOf(AntdTable)).call(this, props));

        _this2.generatePos = function (dataSource, rowKey, _posData) {
            var _level = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;

            var _this = this;
            _.forEach(dataSource, function (item, index) {
                var _position = _level + '_' + index;
                _posData.push({
                    'position': _position,
                    'sameLevel': dataSource.length,
                    'subLevel': item.children ? item.children.length : 0,
                    'key': item[rowKey]
                });
                if (item.children && item.children.constructor === Array) _this.generatePos(item.children, rowKey, _posData, _position);
            });
        };

        _this2.handleSelect = function (record, rowIndex, e) {
            var _this2$props = _this2.props,
                autoSelect = _this2$props.autoSelect,
                dataSource = _this2$props.dataSource,
                rowKey = _this2$props.rowKey;

            var checked = e.target.checked;
            var defaultSelection = _this2.state.selectionDirty ? [] : _this2.getDefaultSelection();
            var selectedRowKeys = _this2.state.selectedRowKeys.concat(defaultSelection);
            var key = _this2.getRecordKey(record, rowIndex);
            if (checked) {
                selectedRowKeys.push(_this2.getRecordKey(record, rowIndex));
            } else {
                selectedRowKeys = selectedRowKeys.filter(function (i) {
                    return key !== i;
                });
            }
            // add by chenlizan begin
            if (autoSelect) {
                //逻辑：父级勾选则全部子集勾选、子集全勾则父级全勾选、子集全取消勾选则父级取消勾选
                _this2.generatePos(dataSource, rowKey, _this2.posData = []);
                _this2.childrenKey(rowIndex, selectedRowKeys, checked);
                _this2.parentKey(rowIndex, selectedRowKeys, checked);
            }
            // add by chenlizan end
            _this2.setState({
                selectionDirty: true
            });
            _this2.setSelectedRowKeys(selectedRowKeys, {
                selectWay: 'onSelect',
                record: record,
                checked: checked
            });
        };

        _this2.ownerTableId = '_owner_' + Date.now();
        return _this2;
    }

    _createClass(AntdTable, [{
        key: 'resetRowsHeight',
        value: function resetRowsHeight(callback) {
            if (this.refRcTable) {
                this.refRcTable.resetRowsHeight(callback);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _classnames,
                _this3 = this;

            var _props = this.props,
                style = _props.style,
                className = _props.className,
                rowKey = _props.rowKey,
                selectionColumnFixed = _props.selectionColumnFixed;

            var restProps = _.assign({}, this.props);
            delete restProps.style;
            delete restProps.className;
            delete restProps.rowKey;
            var data = this.getCurrentPageData();
            var columns = this.renderRowSelection();
            //add by zhuzj-----------begin
            var selectionColumn = _.find(columns, ['key', 'selection-column']);
            if (selectionColumn && selectionColumnFixed) selectionColumn.fixed = 'left'; //固定勾选列
            //add by zhuzj-----------end
            var expandIconAsCell = this.props.expandedRowRender && this.props.expandIconAsCell !== false;
            // const locale = this.getLocale();

            var classString = classnames((_classnames = {}, _defineProperty(_classnames, 'ant-table-' + this.props.size, true), _defineProperty(_classnames, 'ant-table-bordered', this.props.bordered), _classnames));

            columns = this.renderColumnsDropdown(columns);
            columns = columns.map(function (column, i) {
                var newColumn = _.assign({}, column);
                newColumn.key = _this3.getColumnKey(newColumn, i);
                return newColumn;
            });

            // // Empty Data    这是antd的实现，现已改造通过RcTable进行渲染空数据视图，modify by zhuzj
            // let emptyRowKey;
            // if (!data || data.length === 0) {
            //     columns.forEach((column, index) => {
            //         column.render = () => ({
            //             children: !index ? <div className="ant-table-placeholder">{locale.emptyText}</div> : null,
            //             props: {
            //                 colSpan: !index ? columns.length : 0,
            //             },
            //         });
            //     });
            //     emptyRowKey = 'key';
            //     data = [{
            //         [emptyRowKey]: 'empty',
            //     }];
            // }

            var table = [React.createElement(RcTable2, _extends({}, restProps, { //add by dio 使用重写后的RcTable
                ownerTableId: this.ownerTableId,
                ref: function ref(t) {
                    _this3.refRcTable = t;
                },
                data: data,
                columns: columns,
                className: classString
                /*expandIconColumnIndex={(columns[0] && columns[0].key === 'selection-column') ? 1 : 0} modify by zhuzj 固定设置为-1，交RcTable内部处理*/
                , expandIconColumnIndex: -1,
                expandIconAsCell: expandIconAsCell,
                rowKey: rowKey
                /*rowKey={emptyRowKey || rowKey} modify by zhuzj*/
            })), this.renderPagination()];
            // if there is no pagination or no data,
            // the height of spin should decrease by half of pagination
            var paginationPatchClass = this.hasPagination() && data && data.length !== 0 ? 'ant-table-with-pagination' : 'ant-table-without-pagination';
            var spinClassName = this.props.loading ? paginationPatchClass + ' ant-table-spin-holder' : '';
            table = React.createElement(
                Spin,
                { className: spinClassName, spinning: this.props.loading },
                table
            );
            return React.createElement(
                'div',
                { className: className + ' clearfix', style: style },
                table
            );
        }

        // handleSelect = (record, rowIndex, e) => {
        //     const checked = e.target.checked;
        //     const defaultSelection = this.state.selectionDirty ? [] : this.getDefaultSelection();
        //     let selectedRowKeys = this.state.selectedRowKeys.concat(defaultSelection);
        //     let key = this.getRecordKey(record, rowIndex);
        //     if (checked) {
        //         selectedRowKeys.push(this.getRecordKey(record, rowIndex));
        //     } else {
        //         selectedRowKeys = selectedRowKeys.filter((i) => key !== i);
        //     }
        //     this.setState({
        //         selectionDirty: true,
        //     });
        //     this.setSelectedRowKeys(selectedRowKeys, {
        //         selectWay: 'onSelect',
        //         record,
        //         checked,
        //     });
        // }

        /**
         * add by chenlizan
         * 原始数据汇总定位数据
         * @param dataSource 数据数组
         * @param rowKey 表格行 key 的取值
         * @param _posData 定位数据
         * @param _level 起始层
         */

    }, {
        key: 'childrenKey',


        /**
         * add by chenlizan
         * 选中或取消节点子集
         * @param rowIndex 选中行索引值
         * @param selectedRowKeys 选中行索引数据
         * @param flag 选中或不选中
         */
        value: function childrenKey(rowIndex, selectedRowKeys, flag) {
            var posData = this.posData;

            var rowPosData = _.find(posData, { key: rowIndex });
            if (rowPosData.subLevel) {
                _.forEach(posData, function (value) {
                    if (!value.position.indexOf(rowPosData.position + "_")) {
                        flag ? _.indexOf(selectedRowKeys, value.key) == -1 ? selectedRowKeys.push(value.key) : '' : _.pull(selectedRowKeys, value.key);
                    }
                });
            }
        }
    }, {
        key: 'parentKey',


        /**
         * add by chenlizan
         * 选中或取消节点父集
         * @param record
         * @param selectedRowKeys
         * @param flag 全选为true 全否false
         */
        value: function parentKey(rowIndex, selectedRowKeys, flag) {
            //处理同级是否全选或全否
            function getPosForParents(matchKeys) {
                var uniPosMap = {}; //需要显示的所有节点
                _.forEach(matchKeys || [], function (nodePos, index) {
                    var nodePosArr = nodePos ? nodePos.split('_') : [];
                    var posStr = '';
                    for (var _i = 0; _i < nodePosArr.length; _i++) {
                        posStr = posStr + nodePosArr[_i];
                        uniPosMap[posStr] = uniPosMap[posStr] === undefined ? 1 : uniPosMap[posStr] + 1;
                        posStr = posStr + '_';
                    }
                });
                return uniPosMap;
            }

            var posData = this.posData;

            var rowPosData = _.find(posData, { key: rowIndex });
            var parentKeyArr = Object.keys(getPosForParents([rowPosData.position]));
            var i = 1;
            while (i < parentKeyArr.length) {
                var all = true;
                var position = parentKeyArr[parentKeyArr.length - i];
                var itemPosData = _.find(posData, { position: position });
                var parentPosData = _.find(posData, { position: position.split('_').slice(0, position.split('_').length - 1).join('_') });
                if (itemPosData.sameLevel > 0) {
                    //语句括号内逻辑,判断同级节点是否全选
                    var ii = 0;
                    while (ii < itemPosData.sameLevel && all) {
                        var samePosData = _.find(posData, { position: itemPosData.position.split('_').slice(0, itemPosData.position.split('_').length - 1).concat(String(ii)).join('_') });
                        flag ? _.indexOf(selectedRowKeys, samePosData.key) == -1 ? all = false : '' : _.indexOf(selectedRowKeys, samePosData.key) == -1 ? '' : all = false;
                        ii++;
                    }
                }
                if (all && parentPosData) {
                    flag && _.indexOf(selectedRowKeys, parentPosData.key) == -1 ? selectedRowKeys.push(parentPosData.key) : ''; //全选插入上级
                }
                if (parentPosData) {
                    !flag ? _.pull(selectedRowKeys, parentPosData.key) : ''; //未全选弹出上级
                }
                i++;
            }
        }
        /**
         * @override
         */

    }]);

    return AntdTable;
}(Table);

AntdTable.defaultProps = {
    dataSource: [],
    prefixCls: 'ant-table',
    useFixedHeader: false,
    rowSelection: null,
    className: '',
    size: 'large',
    loading: false,
    bordered: false,
    indentSize: 20,
    onChange: noop,
    locale: {},
    rowKey: 'key'
};


module.exports = AntdTable;